/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package beans;

import java.util.logging.Level;
import java.util.logging.Logger;
import javax.annotation.Resource;
import javax.ejb.Stateless;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.Destination;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageProducer;
import javax.jms.Session;
import javax.jms.TemporaryQueue;

/**
 *
 * @author nd195872
 */
@Stateless
public class RequestSender implements RequestSenderLocal {
    
    @Resource(name = "jms/requestQueue")
    private Destination requestQueue;
    @Resource(name = "jms/requestQueueFactory")
    private ConnectionFactory queueFactory;

    @TransactionAttribute(TransactionAttributeType.REQUIRES_NEW)
    public void sendRequest(String requestString, TemporaryQueue replyTo) {
        try {
            // send request message in a sepparate transaction
            Connection connection = queueFactory.createConnection();
            Session session = connection.createSession(true, Session.SESSION_TRANSACTED);
            Message requestMessage = session.createTextMessage(requestString);
            requestMessage.setJMSReplyTo(replyTo);
            MessageProducer producer = session.createProducer(requestQueue);
            producer.send(requestMessage);
            session.close();
            connection.close();
            Logger.getLogger(this.getClass().getName()).log(Level.INFO, "Sent request: "+requestString);
        }
        catch (JMSException ex) {
            Logger.getLogger(this.getClass().getName()).log(Level.SEVERE, null, ex);
           throw new RuntimeException(ex);
        }
    }
 
}
