/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package beans;

import java.util.logging.Level;
import java.util.logging.Logger;
import javax.annotation.Resource;
import javax.ejb.EJB;
import javax.ejb.Stateless;
import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.JMSException;
import javax.jms.MessageConsumer;
import javax.jms.Session;
import javax.jms.TemporaryQueue;
import javax.jms.TextMessage;

/**
 *
 * @author nd195872
 */
@Stateless
public class RequestorSSB implements RequestorSSBLocal {

    @EJB
    private RequestSenderLocal requestSender;
    @Resource(name = "jms/requestQueueFactory")
    private ConnectionFactory queueFactory;

    public String doRequest(String question) {

        String result = "";
        Connection connection = null;
        Session session = null;
        MessageConsumer consumer = null;
        TemporaryQueue tq = null;
        try {
            // create response queue
            connection = queueFactory.createConnection();
            session = connection.createSession(true, Session.SESSION_TRANSACTED);
            tq = session.createTemporaryQueue();

            // create consumer
            consumer = session.createConsumer(tq);
            connection.start();

            // send request in a separate transaction
            Logger.getLogger(this.getClass().getName()).log(Level.INFO, "About to call second SB to send: " + question);

            requestSender.sendRequest(question, tq);

            // receive reply
            TextMessage reply = (TextMessage) consumer.receive(1000);

            if (reply == null) {
                throw new RuntimeException("Reply not received");
            }

            // extract payload
            result = ((TextMessage) reply).getText();

            Logger.getLogger(this.getClass().getName()).log(Level.INFO, "Received reply: " + result);

            consumer.close();
            tq.delete();

        } catch (JMSException ex) {
            Logger.getLogger(this.getClass().getName()).log(Level.SEVERE, null, ex);
            throw new RuntimeException(ex);
        } finally {
            try {

                consumer.close();
                tq.delete();

                if (connection != null) {
                    connection.close();
                }
            } catch (JMSException ex) {
                // error closing connection
                Logger.getLogger(this.getClass().getName()).log(Level.SEVERE, null, ex);
                throw new RuntimeException(ex);
            }
            return result;
        }
    }
}
