/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package beans;

import java.util.logging.Level;
import java.util.logging.Logger;
import javax.annotation.Resource;
import javax.ejb.ActivationConfigProperty;
import javax.ejb.MessageDriven;
import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.Destination;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.MessageProducer;
import javax.jms.Session;
import javax.jms.TextMessage;

@MessageDriven(mappedName = "jms/requestQueue", activationConfig =  {
        @ActivationConfigProperty(propertyName = "acknowledgeMode", propertyValue = "Auto-acknowledge"),
        @ActivationConfigProperty(propertyName = "destinationType", propertyValue = "javax.jms.Queue")
    })
public class ResponderMDB implements MessageListener {

    @Resource(name = "jms/replyQueueFactory")
    private ConnectionFactory queueFactory;
    
    public ResponderMDB() {
    }

    public void onMessage(Message requestMessage) {
       Logger.getLogger(this.getClass().getName()).log(Level.INFO, "Received request");

        try {
            // extract payload
            String payloadString = ((TextMessage)requestMessage).getText();

            // send response message
            Connection connection = queueFactory.createConnection();
            Session session = connection.createSession(true, Session.SESSION_TRANSACTED);
            Message responseMessage = session.createTextMessage("Reply to "+payloadString);
            Destination replyQueue = requestMessage.getJMSReplyTo();
            MessageProducer producer = session.createProducer(replyQueue);
            producer.send(responseMessage);
            session.close();
            connection.close();
        }
        catch (JMSException ex) {
            Logger.getLogger(this.getClass().getName()).log(Level.SEVERE, null, ex);
           throw new RuntimeException(ex);
        }
    }
    
}
